#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__="atareao"
__date__ ="$29-ene-2011$"
#
# com.py
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
from gi.repository import GdkPixbuf
import os

######################################

def is_package():
    return __file__.find('src') < 0

######################################

__author__ = 'Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'
__date__ ='$16/06/2012'
__copyright__ = 'Copyright (c) 2011 Lorenzo Carbonell'
__license__ = 'GPLV3'
__url__ = 'http://www.atareao.es'
__version__ = '0.4.1.0'

VERSION = __version__
APP = 'translate-me'
APP_CONF = APP + '.conf'
APPNAME = APP.capitalize()
KEY = 'apps.translate-me'
CONFIG_DIR = os.path.join(os.path.expanduser('~'),'.config')
CONFIG_APP_DIR = os.path.join(CONFIG_DIR, APP)
CONFIG_FILE = os.path.join(CONFIG_APP_DIR, APP_CONF)

# check if running from source
if is_package():
	ROOTDIR = '/usr/share/'
	LANGDIR = os.path.join(ROOTDIR, 'locale-langpack')
	APPDIR = os.path.join(ROOTDIR, APP)
	IMGDIR = os.path.join(APPDIR, APP)
	ICON = GdkPixbuf.Pixbuf.new_from_file('/usr/share/pixmaps/translate-me.svg')
else:
	VERSION = VERSION + '-src'
	ROOTDIR = os.path.dirname(__file__)
	LANGDIR = os.path.normpath(os.path.join(ROOTDIR, '../po'))
	APPDIR = ROOTDIR
	IMGDIR = os.path.normpath(os.path.join(ROOTDIR, '../data/icons'))
	ICON = GdkPixbuf.Pixbuf.new_from_file(os.path.join(IMGDIR, 'translate-me.svg'))










