#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__='atareao'
__date__ ='$09/07/2011'
#
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import ConfigParser
import os


import comun

PARAMS = {	'default':{ 'value':'','default':'en-es'},
			'font-from':{ 'value':'','default':'Ubuntu 14'},
			'font-to':{ 'value':'','default':'Ubuntu 14'},
			'width':{'value':'','default':'400'},
			'height':{'value':'','default':'400'}
			}

class Configuration(object):
	
	def __init__(self):
		self.params = PARAMS
		self.config = ConfigParser.RawConfigParser()
		self.read()
	
	def get(self,key):
		value = self.params[key]['value']
		if value == None or value == '':
			value = self.params[key]['default']
			self.params[key]['value'] = value
		return value

	def set(self,key,value):
		if value == None or value == '':
			value = self.params[key]['default']
		self.params[key]['value'] = value
			
	def read_params(self):
		for key in self.params.keys():
			value = self._get_value(key)
			if value == None or value == '':
				value = self.params[key]['default']
			self.params[key]['value'] = value
	
	def save_params(self):
		if not self.config.has_section('Configuration'):
			self.config.add_section('Configuration')		
		for key in self.params.keys():
			value = self.params[key]['value']
			if value == None or value == '':
				value = self.params[key]['default']
			self.config.set('Configuration', key, value)

	def read(self):
		self.config.read(comun.CONFIG_FILE)
		self.read_params()
	
	def _get_value(self,key):
		try:
			value = self.config.get('Configuration', key)
		except Exception,e:
			value = None
		if value == 'None':
			value = None
		return value
		

	def create(self):
		if not self.config.has_section('Configuration'):
			self.config.add_section('Configuration')
		self.set_defaults()
	
	def set_defaults(self):
		for key in self.params.keys():
			value = self.get_value(key)
			if value == None or value == '':
				value = self.params[key]['default']
				self.params[key]['value'] = value

	def save(self):
		self.save_params()
		if not os.path.exists(comun.CONFIG_APP_DIR):
			os.makedirs(comun.CONFIG_APP_DIR)
		self.config.write(open(comun.CONFIG_FILE, 'w'))
      
if __name__=='__main__':
	configuration = Configuration()
	configuration.read()
	print 'user %s'%configuration.get('user')
	#configuration.password = 'tteesfffaa'
