#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#

from gi.repository import Gtk
from configurator import Configuration
import locale
import gettext
import comun
import translator

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext

class Preferences(Gtk.Dialog):
	def __init__(self,parent=None):
		Gtk.Dialog.__init__(self,'Translate-Me | '+_('Preferences'),parent,Gtk.DialogFlags.MODAL | Gtk.DialogFlags.DESTROY_WITH_PARENT,(Gtk.STOCK_CANCEL, Gtk.ResponseType.REJECT,Gtk.STOCK_OK, Gtk.ResponseType.ACCEPT))
		self.configurator = Configuration()
		#
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.set_title('translate-me | '+_('Preferences'))
		self.set_size_request(350, 120)
		self.set_resizable(False)
		self.set_icon(comun.ICON)		
		self.connect('destroy', self.close_application)
		#
		vbox0 = Gtk.VBox(spacing = 5)
		vbox0.set_border_width(5)
		self.get_content_area().add(vbox0)
		#
		notebook = Gtk.Notebook()
		vbox0.add(notebook)
		#
		vbox1 = Gtk.VBox(spacing = 5)
		vbox1.set_border_width(5)
		notebook.append_page(vbox1,Gtk.Label.new(_('Languages')))
		#
		vbox2 = Gtk.VBox(spacing = 5)
		vbox2.set_border_width(5)
		notebook.append_page(vbox2,Gtk.Label.new(_('Text size')))
		#
		hbox11 = Gtk.HBox()
		vbox1.pack_start(hbox11,True,False,0)
		#
		label11 = Gtk.Label.new(_('Default')+':')
		hbox11.pack_start(label11,True,False,0)
		#
		#
		model = Gtk.ListStore(str,str)
		for translation in translator.get_key_translation():
			model.append(translation)
		self.combobox1 = Gtk.ComboBox.new_with_model(model)
		renderer_text = Gtk.CellRendererText()
		self.combobox1.pack_start(renderer_text, True)
		self.combobox1.add_attribute(renderer_text, "text", 0)				
		vbox1.pack_start(self.combobox1,False,False,0)				
		#
		self.fontbutton1 = Gtk.FontButton()
		vbox2.pack_start(self.fontbutton1,False,False,0)
		#
		self.fontbutton2 = Gtk.FontButton()
		vbox2.pack_start(self.fontbutton2,False,False,0)
		#
		self.load_preferences()
		#
		self.show_all()

	def load_preferences(self):
		default=self.configurator.get('default')
		font_from = self.configurator.get('font-from')
		font_to = self.configurator.get('font-to')
		#
		self.set_translation_seleted(default)
		self.fontbutton1.set_font_name(font_from)
		self.fontbutton2.set_font_name(font_to)
		
	def save_preferences(self):
		self.configurator.set('default',self.get_translation_selected())
		self.configurator.set('font-from',self.fontbutton1.get_font_name())
		self.configurator.set('font-to',self.fontbutton2.get_font_name())
		self.configurator.save()

	def close_application(self, widget):
		self.ok = False
		self.destroy()
	
	def get_translation_selected(self):
		tree_iter = self.combobox1.get_active_iter()
		if tree_iter != None:
			model = self.combobox1.get_model()
			translation = model[tree_iter][1]
			return translation

	def set_translation_seleted(self,translation):
		model = self.combobox1.get_model()
		tree_iter = model.get_iter_first()
		if tree_iter!=None:
			while tree_iter!=None and model[tree_iter][1]!=translation:
				print '%s = %s'%(model[tree_iter][1],translation)
				tree_iter = model.iter_next(tree_iter)
			if tree_iter!=None and model[tree_iter][1] == translation:
				self.combobox1.set_active_iter(tree_iter)
				return True
		self.combobox1.set_active(0)
		return False
							
if __name__ == "__main__":
	p = Preferences(None)
	if p.run() == Gtk.ResponseType.ACCEPT:
		p.save_preferences()
	p.destroy		
	exit(0)
		
