#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
from gi.repository import Gtk, Gdk, Pango
import locale
import gettext
import comun
import webbrowser
from configurator import Configuration
from preferences import Preferences
import translator

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext

def add2menu(menu, text = None, icon = None, conector_event = None, conector_action = None):
	if text != None and icon == None:
		menu_item = Gtk.MenuItem(text)
	elif text == None and icon != None:
		menu_item = Gtk.ImageMenuItem.new_from_stock(icon, None)
		menu_item.set_always_show_image(True)
	elif text != None and icon != None:
		menu_item = Gtk.ImageMenuItem.new_from_stock(icon, None)
		menu_item.set_text(text)
		menu_item.set_always_show_image(True)
	elif icon == None:
		menu_item = Gtk.MenuItem(text)
	else:
		menu_item = Gtk.SeparatorMenuItem()
	if conector_event != None and conector_action != None:				
		menu_item.connect(conector_event,conector_action)
	menu_item.show()
	menu.append(menu_item)
	return menu_item

class TM(Gtk.Window):
	def __init__(self):
		#
		self.configurator = Configuration()
		#
		Gtk.Window.__init__(self)
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.set_title('Translate-me')
		width = int(self.configurator.get('width'))
		height = int(self.configurator.get('height'))
		self.set_default_size(width, height)
		self.set_icon(comun.ICON)
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.connect('destroy', self.close_application)
		self.connect('configure-event', self.on_configure_event)		
		#
		vbox = Gtk.VBox()#spacing = 5)
		#vbox.set_border_width(5)
		self.add(vbox)
		#
		self.menubar = Gtk.MenuBar()
		################################################################
		menu = Gtk.Menu()
		add2menu(menu, text = None, icon = Gtk.STOCK_QUIT, conector_event = 'activate', conector_action = self.close_application)
		filem = Gtk.MenuItem(_('File'))
		filem.set_submenu(menu)
		self.menubar.append(filem)
		################################################################
		menu = Gtk.Menu()
		add2menu(menu, text = None, icon = Gtk.STOCK_PREFERENCES, conector_event = 'activate', conector_action = self.on_preferences_activate)
		filee = Gtk.MenuItem(_('Edit'))
		filee.set_submenu(menu)
		self.menubar.append(filee)
		################################################################
		self.fileh = Gtk.MenuItem(_('Help'))
		self.fileh.set_submenu(self.get_help_menu())
		#
		self.menubar.append(self.fileh)
		################################################################
		vbox.pack_start(self.menubar,False,False,0)			
		#
		frame = Gtk.Frame()
		vbox.add(frame)
		#
		vbox1 = Gtk.VBox(spacing = 5)
		vbox1.set_border_width(5)
		frame.add(vbox1)
		#
		model = Gtk.ListStore(str,str)
		for translation in translator.get_key_translation():
			model.append(translation)
		self.combobox1 = Gtk.ComboBox.new_with_model(model)
		renderer_text = Gtk.CellRendererText()
		self.combobox1.pack_start(renderer_text, True)
		self.combobox1.add_attribute(renderer_text, "text", 0)		
		self.combobox1.set_active(0)
		vbox1.pack_start(self.combobox1,False,False,0)
		#
		scrolledwindow1 = Gtk.ScrolledWindow()
		scrolledwindow1.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
		scrolledwindow1.set_shadow_type(Gtk.ShadowType.ETCHED_OUT)
		vbox1.pack_start(scrolledwindow1,True,True,0)
		self.entry1 = Gtk.TextView()
		self.entry1.set_wrap_mode(Gtk.WrapMode.WORD)
		self.entry1.connect('key_press_event',self.on_key_press_event_in_entry1)
		scrolledwindow1.add(self.entry1)
		#
		hbox1 = Gtk.HBox()
		vbox1.pack_start(hbox1,False,False,0)
		self.button_clear1 = Gtk.Button(_('Erase'))
		self.button_clear1.connect('clicked',self.on_button1_clear_clic)
		hbox1.pack_end(self.button_clear1,False,False,0)
		#
		self.button1 = Gtk.Button(_('Translate'))
		self.button1.connect('clicked',self.on_button1_clicked)
		vbox1.pack_start(self.button1,True,False,0)
		#
		scrolledwindow2 = Gtk.ScrolledWindow()
		scrolledwindow2.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
		scrolledwindow2.set_shadow_type(Gtk.ShadowType.ETCHED_OUT)
		vbox1.pack_start(scrolledwindow2,True,True,0)
		self.entry2 = Gtk.TextView()
		self.entry2.set_wrap_mode(Gtk.WrapMode.WORD)
		scrolledwindow2.add(self.entry2)
		#
		hbox3 = Gtk.HBox()
		vbox1.pack_start(hbox3,False,False,0)
		self.button_clear2 = Gtk.Button(_('Erase'))
		self.button_clear2.connect('clicked',self.on_button2_clear_clic)
		hbox3.pack_end(self.button_clear2,False,False,0)
		#
		self.load_preferences()
		self.show_all()
	
	def get_help_menu(self):
		help_menu =Gtk.Menu()
		#		
		add2menu(help_menu,text = _('Web...'),conector_event = 'activate',conector_action = self.on_menu_project_clicked)
		add2menu(help_menu,text = _('Get help online...'),conector_event = 'activate',conector_action = self.on_menu_help_online_clicked)
		add2menu(help_menu,text = _('Translate this application...'),conector_event = 'activate',conector_action = self.on_menu_translations_clicked)
		add2menu(help_menu,text = _('Report a bug...'),conector_event = 'activate',conector_action = self.on_menu_bugs_clicked)
		add2menu(help_menu)
		add2menu(help_menu,text = _('About'),conector_event = 'activate',conector_action = self.menu_about_response)
		#
		help_menu.show()
		#
		return help_menu

	def on_menu_project_clicked(self,widget):
		webbrowser.open('https://launchpad.net/translate-me')
		
	def on_menu_help_online_clicked(self,widget):
		webbrowser.open('https://answers.launchpad.net/translate-me')
	
	def on_menu_translations_clicked(self,widget):
		webbrowser.open('https://translations.launchpad.net/translate-me')
	
	def on_menu_bugs_clicked(self,widget):
		webbrowser.open('https://bugs.launchpad.net/translate-me')
		
	def get_translation_selected(self):
		tree_iter = self.combobox1.get_active_iter()
		if tree_iter != None:
			model = self.combobox1.get_model()
			translation = model[tree_iter][1]
			return translation

	def set_translation_seleted(self,translation):
		model = self.combobox1.get_model()
		tree_iter = model.get_iter_first()
		if tree_iter!=None:
			while tree_iter!=None and model[tree_iter][1]!=translation:
				tree_iter = model.iter_next(tree_iter)
			if tree_iter!=None and model[tree_iter][1] == translation:
				self.combobox1.set_active_iter(tree_iter)
				return True
		self.combobox1.set_active(0)
		return False		
	
	def on_key_press_event_in_entry1(self,widget,event):
		if event.state & Gtk.accelerator_get_default_mod_mask() == Gdk.ModifierType.CONTROL_MASK and event.keyval == 65293:
			self.de_a()

	def on_button1_clear_clic(self,widget):
		self.entry1.get_buffer().set_text('')

	def on_button2_clear_clic(self,widget):
		self.entry2.get_buffer().set_text('')
	def on_configure_event(self,widget, event):
		self.width = event.width
		self.height = event.height
	def on_preferences_activate(self,widget):
		p = Preferences(self)
		if p.run() == Gtk.ResponseType.ACCEPT:
			p.save_preferences()
			self.load_preferences()
		p.hide()
		p.destroy		
		
	def close_application(self,widget):
		width = int(self.configurator.get('width'))
		height = int(self.configurator.get('height'))
		if width != self.width or height != self.height:
			self.configurator.set('width',str(self.width))
			self.configurator.set('height',str(self.height))
			self.configurator.save()
		exit(0)
		
	def existe(self,cadena):
		if cadena:
			for element in self.model:
				if element[0].startswith(cadena):
					return True
		return False
		
	def de_a(self):
		tbuffer =self.entry1.get_buffer()
		inicio = tbuffer.get_start_iter()
		fin = tbuffer.get_end_iter()
		text = tbuffer.get_text(inicio,fin,True)
		#
		language, output_encoding = locale.getdefaultlocale()
		to_translate = text.decode(output_encoding)
		#
		translation = self.get_translation_selected()
		print translation
		translated_text = translator.translate(to_translate,translation)
		#
		ttbuffer=Gtk.TextBuffer()
		ttbuffer.set_text(translated_text)
		self.entry2.set_buffer(ttbuffer)
	
	def on_button1_clicked(self,widget):
		self.de_a()

		
	

	def menu_about_response(self,widget):
		ad=Gtk.AboutDialog()
		ad.set_name(comun.APPNAME)
		ad.set_version(comun.VERSION)
		ad.set_copyright('Copyrignt (c) 2010,2011,2012\nLorenzo Carbonell')
		ad.set_comments(_('A simple application to translate'))
		ad.set_license(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.')
		ad.set_website('https://launchpad.net/translate-me')
		ad.set_website_label('https://launchpad.net/translate-me')
		ad.set_authors(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_translator_credits(''+
		'Enbata <https://launchpad.net/~peionz>\n'+
		'Eugene Marshal <https://launchpad.net/~lowrider>\n'+
		'Fitoschido <https://launchpad.net/~fitoschido>\n'+
		'Lorenzo Carbonell <https://launchpad.net/~lorenzo-carbonell>\n'+
		'Jan Dolejš <https://launchpad.net/~jackdown3csr>\n'+
		'mercier133 <https://launchpad.net/~mercierdamien>\n'+
		'Мирослав Николић <https://launchpad.net/~lipek>\n'+
		'Pavel <https://launchpad.net/~rustynail>\n'+
		'pkramerruiz <https://launchpad.net/~pkramerruiz>\n'+
		'zeugma <https://launchpad.net/~sunder67>\n')	
		ad.set_program_name(comun.APPNAME)
		ad.set_logo(comun.ICON)
		ad.run()
		ad.hide()

	def load_preferences(self):
		default=self.configurator.get('default')
		font_from = self.configurator.get('font-from')
		font_to = self.configurator.get('font-to')
		#
		self.set_translation_seleted(default)
		self.entry1.modify_font(Pango.FontDescription(font_from))
		self.entry2.modify_font(Pango.FontDescription(font_to))

if __name__ == "__main__":
	v = TM()
	Gtk.main()
	exit(0)

